﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace Win_Flex_EditMode
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void c1FlexGrid1_KeyDownEdit(object sender, C1.Win.C1FlexGrid.KeyEditEventArgs e)
        {
            //Get the current cell's Editor As a TextBox
            TextBox tb = (TextBox)this.C1FlexGrid1.Editor;
            if (tb.SelectionLength == 0)
            {
                //If the Caret is at the end of the Text (right edge) in TextBox 
                if (tb.SelectionStart == tb.Text.Length)
                {
                    //then on the press of Right arrow key 
                    //the cursor should move to the next column in same row
                    if (e.KeyData == Keys.Right)
                    {
                        if (e.Col < C1FlexGrid1.Cols.Count-1)
                        {
                            C1FlexGrid1.Select(e.Row, e.Col + 1);
                        }
                        else
                        {
                            //if it is the last column in the grid then end editing
                            C1FlexGrid1.Select(e.Row, e.Col);
                            C1FlexGrid1.FinishEditing();
                        }
                    }
                    //If the Caret is at the start of the Text (left edge) in TextBox 
                }
                else if (tb.SelectionStart == 0)
                {
                    //then on the press of Left arrow key
                    //the cursor should move to the previous column in the same row
                    if (e.KeyData == Keys.Left)
                    {
                        if (e.Col > 1)
                        {
                            C1FlexGrid1.Select(e.Row, e.Col - 1);
                        }
                        else
                        {
                            //if it is the first column in the grid then end editing
                            C1FlexGrid1.Select(e.Row, e.Col);
                            C1FlexGrid1.FinishEditing();
                        }
                    }
                }
            }
         }

        private void Form1_Load(object sender, EventArgs e)
        {
            C1FlexGrid1[1, 1] = "FlexGrid";
        }
    }
}
